Unit IntvSnd;

Interface

Const
  _32BIT_OPERAND = $66;
  _32BIT_ADDRESS = $67;
{
  AY_AFINE    = 0;
  AY_ACOARSE  = 1;
  AY_BFINE    = 2;
  AY_BCOARSE  = 3;
  AY_CFINE    = 4;
  AY_CCOARSE  = 5;
  AY_NOISEPER = 6;
  AY_ENABLE   = 7;
  AY_AVOL     = 8;
  AY_BVOL     = 9;
  AY_CVOL     = 10;
  AY_EFINE    = 11;
  AY_ECOARSE  = 12;
  AY_ESHAPE   = 13;
  AY_PORTA    = 14;
  AY_PORTB    = 15;
}
  AY_AFINE    = 0;
  AY_BFINE    = 1;
  AY_CFINE    = 2;
  AY_EFINE    = 3;
  AY_ACOARSE  = 4;
  AY_BCOARSE  = 5;
  AY_CCOARSE  = 6;
  AY_ECOARSE  = 7;

  AY_ENABLE   = 8;
  AY_NOISEPER = 9;
  AY_ESHAPE   = 10;

  AY_AVOL     = 11;
  AY_BVOL     = 12;
  AY_CVOL     = 13;

  AY_PORTA    = 14;
  AY_PORTB    = 15;

  MaxNumChips = 2;

{ default clock frequency, frequency in MHz * 100 }

{  AY8910_CLOCK = 1500000000;}       { 1.832727040 MHZ }

  AY8910_CLOCK = 1789772;{2000000;}

{  SAMPLE_RATE  = 22050;}
  MAX_BUF_SIZE = {256;}128;{64;}
  Sound_Is_Init  : Boolean = False;
  Sample_Pos     : LongInt = 0;
  Sample_Counter : LongInt = 0;
  Sample_Mul     : LongInt = 4;
  _AYEnvForms : Array[0..15,0..31] Of Integer = (
    ( 15, 14, 13, 12, 11, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ),
    ( 15, 14, 13, 12, 11, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ),
    ( 15, 14, 13, 12, 11, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ),
    ( 15, 14, 13, 12, 11, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ),
    (  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ),
    (  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ),
    (  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ),
    (  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ),
    ( 15, 14, 13, 12, 11, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0,
      15, 14, 13, 12, 11, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0 ),
    ( 15, 14, 13, 12, 11, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ),
    ( 15, 14, 13, 12, 11, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0,
       0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 ),
    ( 15, 14, 13, 12, 11, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15 ),
    (  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
       0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15 ),
    (  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15, 15 ),
    (  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
      15, 14, 13, 12, 11, 10,  9,  8,  7,  6,  5,  4,  3,  2,  1,  0 ),
    (  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
       0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 )
);

Var
  Buf         : Array[0..MAX_BUF_SIZE - 1] Of Byte; { Sound buffer }
  DToA        : Array[0..15] Of Byte;
  AYRegs      : Array[0..18,0..MaxNumChips - 1] Of Word;

  Incr0       : Array[0..MaxNumChips - 1] Of Integer; {LongInt;}
  Incr1       : Array[0..MaxNumChips - 1] Of Integer; {LongInt;}
  Incr2       : Array[0..MaxNumChips - 1] Of Integer; {LongInt;}
  IncrEnv     : Array[0..MaxNumChips - 1] Of LongInt;
  IncrNoise   : Array[0..MaxNumChips - 1] Of LongInt;
  Counter0    : Array[0..MaxNumChips - 1] Of Integer;
  Counter1    : Array[0..MaxNumChips - 1] Of Integer;
  Counter2    : Array[0..MaxNumChips - 1] Of Integer;
  CountEnv    : Array[0..MaxNumChips - 1] Of LongInt;
  CountNoise  : Array[0..MaxNumChips - 1] Of LongInt;
  NoiseGen    : Array[0..MaxNumChips - 1] Of LongInt;
  Envelope    : Array[0..MaxNumChips - 1] Of Integer;
  StateNoise  : Array[0..MaxNumChips - 1] Of Byte;
  NumChips    : Integer;

  Vol0        : Integer;
  Vol1        : Integer;
  Vol2        : Integer;
  VolNoise    : Array[0..MaxNumChips - 1] Of Integer;

  VoiceReady  : Boolean;
  VoicePtr    : Pointer;
  VoiceLen    : Word;
  VoicePos    : Word;
  VoiceFIFO   : Array[0..63] Of Word;
  VoiceFRead  : Word;
  VoiceFWrite : Word;

  SmallSoundBuf : Array[0..2 * MAX_BUF_SIZE + 15] Of Byte;

  VolScale  : Array[0..16,0..31] Of Byte;
  VoiceBuf  : Array[0..127] Of Byte;
  VoiceProc : Pointer;

Procedure WriteToPSG(tAddr,Value,Chip: Word);
Procedure InitSound(Playback_Freq,Chips: Word; Reset: Boolean);
Procedure StopSound;

Implementation

Uses HexWrite,{G320,}Dos,IntvMnu;

Const
  Last_Pos : LongInt = 80;

Var
  SndLogFile : System.Text;

{
  Vol0        : Integer;
  Vol1        : Integer;
  Vol2        : Integer;
  VolNoise    : Array[0..MaxNumChips - 1] Of Integer;
}


  AYSoundRate : LongInt;         { Output rate (Hz) }
  AYBufSize   : Integer;         { Size of sound buffer, in samples }
{  DOS_Timer_Handler : Pointer;}

  _Intr_Num                      : Byte;
  _Voice_Status                  : Word;
  _IO_Addx                       : Word;
  _DMA                           : Word;
  _DSP_Version                   : Word;
  Org_Int_Addx                   : Pointer;
  BufPlaying                     : Byte;
  BufToFill                      : Byte;

  PSmallSoundBuf                 : Pointer;
  BufScan                        : LongInt;
  PFillBuffer                    : Pointer;

{$F+}
Function _CTV_Card_Here: Word; External;
Function _CTV_Detect: Word;    External;
Function _CTV_Output(Buf: Pointer; BufLen,SampleRate: Word): Word; External;
Function _CTV_Halt: Word;      External;
Function _CTV_Uninstall: Word; External;
{$F-}
{$L CTV-ATA6.OBJ}

{$F+}
Procedure ProcessSound; External;
{$F-}
{$L IPROCESS.OBJ}
(*
Procedure TimerHandler0;
Var
  I,J,X          : Integer;
  C0,C1          : Integer;
  L0,L1,L2       : Array[0..MaxNumChips - 1] Of Integer;

  VolTemp0 : Byte;
  VolTemp1 : Byte;
  VolTemp2 : Byte;
  P        : Pointer;

  CE : LongInt;

  Chip : Integer;

Begin

 { if a sample was played, than ONLY the sample is on output! }
 { this is true for all vectrex stuff, if otherwise needed,   }
 { remove the else from sample_pos                            }
 { and or the stuff to Buf[]                                  }

 If Sample_Pos > 10 Then { spike playes a one byte 0 sample all through the game... }
 Begin

  { the following is a weak attempt to }
  { synchronize to the sample rate...  }
  { handled by buffer size instead of  }
  { AYSoundRate                        }

   Last_Pos := 80;
   If sample_pos < AYBufSize Then
   Begin
    If abs(last_pos - sample_pos) < 15 Then
     sample_mul := (AYBufSize + (sample_pos - (sample_pos Shr 2))) Div sample_pos;
   End;
   last_pos := sample_pos;
   For i := sample_counter To AYBufSize - 1 Do
    Buf[i] := Buf[sample_counter-1];
   sample_counter := 0;
   sample_pos := 0;
 End
 Else
 Begin
  x := AYRegs[AY_AFINE] + ((AYRegs[AY_ACOARSE] And $F) Shl 8);
  If X <> 0 Then Incr0 := Trunc(AY8910_CLOCK / AYSoundRate * 4 / x) Else Incr0 := 0;

  x := AYRegs[AY_BFINE] + ((AYRegs[AY_BCOARSE] And $F) Shl 8);
  If X <> 0 Then Incr1 := Trunc(AY8910_CLOCK / AYSoundRate * 4 / x) Else Incr1 := 0;

  x := AYRegs[AY_CFINE] + ((AYRegs[AY_CCOARSE] And $F) Shl 8);
  If X <> 0 Then Incr2 := Trunc(AY8910_CLOCK / AYSoundRate * 4 / x) Else Incr2 := 0;

  x := AYRegs[AY_NOISEPER] And $1F;
  If X <> 0
   Then IncrNoise := Trunc(AY8910_CLOCK / AYSoundRate * 4 / X)
   Else IncrNoise := Trunc(AY8910_CLOCK / AYSoundRate * 4);

  x := AYRegs[AY_EFINE] + (AYRegs[AY_ECOARSE] Shl 8);
  If X <> 0 Then IncrEnv := Trunc(AY8910_CLOCK / AYSoundRate * 4 / x * AYBufSize) Else IncrEnv := 0;

  Envelope := _AYEnvForms[AYRegs[AY_ESHAPE],(CountEnv Shr 16) And $1F];

  Inc(CountEnv,IncrEnv);
  If (CountEnv And $FFE00000) <> 0 Then
  Begin
   Case AYRegs[AY_ESHAPE] Of
    8,10,12,14:
      Dec(CountEnv,$200000);
    Else
      CountEnv := $100000;
      IncrEnv  := 0;
   End; { Case }
  End;

  If AYRegs[AY_AVOL] < 16 Then Vol0 := AYRegs[AY_AVOL] Else Vol0 := Envelope;
  If AYRegs[AY_BVOL] < 16 Then Vol1 := AYRegs[AY_BVOL] Else Vol1 := Envelope;
  If AYRegs[AY_CVOL] < 16 Then Vol2 := AYRegs[AY_CVOL] Else Vol2 := Envelope;

  If (AYRegs[AY_ENABLE] And $08) <> 0 Then VolTemp0 := 0 Else VolTemp0 := Vol0;
  If (AYRegs[AY_ENABLE] And $10) <> 0 Then VolTemp1 := 0 Else VolTemp1 := Vol1;
  If (AYRegs[AY_ENABLE] And $20) <> 0 Then VolTemp2 := 0 Else VolTemp2 := Vol2;

  VolNoise := (VolTemp0 + VolTemp1 + VolTemp2){ Div 2};

  If (AYRegs[AY_ENABLE] And 1) <> 0 Then Vol0 := 0;
  If (AYRegs[AY_ENABLE] And 2) <> 0 Then Vol1 := 0;
  If (AYRegs[AY_ENABLE] And 4) <> 0 Then Vol2 := 0;



  For i := 0 To AYBufSize - 1 Do
  Begin

   {* These strange tricks are needed for getting rid   }
   {* of nasty interferences between sampling frequency }
   {* and "rectangular sound" (which is also the output }
   {* of real AY-3-8910) we produce.                    }

   c0 :=  Counter0;
   c1 :=  Counter0 + Incr0;

   If (C0 And $8000) <> 0 Then L0 := -16 Else L0 := 16;
   If ((c0 Xor c1) And $8000) <> 0 Then
    l0 := Round(l0 * ($8000 - (c0 And $7FFF) - (c1 And $7FFF)) / Incr0);

   Counter0 := c1 And $FFFF;

   c0 :=  Counter1;
   c1 :=  Counter1 + Incr1;

   If (C0 And $8000) <> 0 Then L1 := -16 Else L1 := 16;
   If ((c0 Xor c1) And $8000) <> 0 Then
    l1 := Round(l1 * ($8000 - (c0 And $7FFF) - (c1 And $7FFF)) / Incr1);

   Counter1 := c1 And $FFFF;

   c0 :=  Counter2;
   c1 :=  Counter2 + Incr2;

   If (C0 And $8000) <> 0 Then L2 := -16 Else L2 := 16;
   If ((c0 Xor c1) And $8000) <> 0 Then
    l2 := Round(l2 * ($8000 - (c0 And $7FFF) - (c1 And $7FFF)) / Incr2);

   Counter2 := c1 And $FFFF;

   CountNoise := (CountNoise And $FFFF) + IncrNoise;

   If (CountNoise And $FFFF0000) <> 0 Then
   Begin

    {* The following code is a random bit generator :) }

    NoiseGen := NoiseGen Shl 1;
    If (NoiseGen And $80000000) <> 0 Then NoiseGen := NoiseGen Xor $00040001;
    StateNoise := NoiseGen And 1;
   End;

   If StateNoise <> 0
    Then Buf[I] := Round((l0 * Vol0 + l1 * Vol1 + l2 * Vol2) / 3) + Round(VolNoise / 1.5)
    Else Buf[I] := Round((l0 * Vol0 + l1 * Vol1 + l2 * Vol2) / 3) - Round(VolNoise / 1.5);
  End; { For I }
 End;

  For i := 0 To AYBufSize - 1 Do
  Begin

   {* These strange tricks are needed for getting rid   }
   {* of nasty interferences between sampling frequency }
   {* and "rectangular sound" (which is also the output }
   {* of real AY-3-8910) we produce.                    }

   c0 :=  Counter0;
   c1 :=  Counter0 + Incr0;

   If C0 < 0 Then L0 := -1 Else L0 := 1;
   If ((c0 Xor c1) And $8000) <> 0 Then
    l0 := Round(l0 * ($8000 - (c0 And $7FFF) - (c1 And $7FFF)) / Incr0);

   Counter0 := c1 And $FFFF;

   c0 :=  Counter1;
   c1 :=  Counter1 + Incr1;

   If C0 < 0 Then L1 := -1 Else L1 := 1;
   If ((c0 Xor c1) And $8000) <> 0 Then
    l1 := Round(l1 * ($8000 - (c0 And $7FFF) - (c1 And $7FFF)) / Incr1);

   Counter1 := c1 And $FFFF;

   c0 :=  Counter2;
   c1 :=  Counter2 + Incr2;

   If C0 < 0 Then L2 := -1 Else L2 := 1;
   If ((c0 Xor c1) And $8000) <> 0 Then
    l2 := Round(l2 * ($8000 - (c0 And $7FFF) - (c1 And $7FFF)) / Incr2);

   Counter2 := c1 And $FFFF;

   CountNoise := (CountNoise And $FFFF) + IncrNoise;

   If (CountNoise And $FFFF0000) <> 0 Then
   Begin

    {* The following code is a random bit generator :) }

    NoiseGen := NoiseGen Shl 1;
    If (NoiseGen And $80000000) <> 0 Then NoiseGen := NoiseGen Xor $00040001;
    StateNoise := NoiseGen And 1;
   End;

   If StateNoise <> 0
    Then Buf[I] := Round((l0 * Vol0 + l1 * Vol1 + l2 * Vol2){ / 3}) + {Round(}VolNoise{ / 1.5)}
    Else Buf[I] := Round((l0 * Vol0 + l1 * Vol1 + l2 * Vol2){ / 3}){ - Round(VolNoise / 1.5)};
  End; { For I }


 End;

 { upload the data to the audio DRAM local memory }

 P := Pointer(LongInt(PSmallSoundBuf) + ((BufPlaying Xor 1) * MAX_BUF_SIZE));
 Move(Buf,P^,AYBufSize);
End; { TimerHandler0 }
*)
(*
Procedure TimerHandler;
Var
  I,J,X          : Integer;
  C0,C1          : Integer;
  L0,L1,L2       : Array[0..MaxNumChips - 1] Of Integer;

  VolTemp0 : Byte;
  VolTemp1 : Byte;
  VolTemp2 : Byte;
  P        : Pointer;

  CE : LongInt;

  Chip : Integer;

Begin

 { if a sample was played, than ONLY the sample is on output! }
 { this is true for all vectrex stuff, if otherwise needed,   }
 { remove the else from sample_pos                            }
 { and or the stuff to Buf[]                                  }

 For I := 0 To AYBufSize - 1 Do
 Begin

  For Chip := 0 To NumChips - 1 Do
  Begin

   Envelope[Chip] := DToA[_AYEnvForms[AYRegs[AY_ESHAPE,Chip],(CountEnv[Chip] Shr 16) And $1F]];

   If (CountEnv[Chip] And $FFE00000) <> 0 Then
   Begin
     Case AYRegs[AY_ESHAPE,Chip] Of
      8,10,12,14:
        Dec(CountEnv[Chip],$200000);
      Else
        CountEnv[Chip] := $100000;
        IncrEnv[Chip]  := 0;
     End; { Case }
   End;
   Inc(CountEnv[Chip],IncrEnv[Chip]);

   If AYRegs[AY_AVOL,Chip] < 16 Then Vol0 := AYRegs[AY_AVOL,Chip] * 2 Else Vol0 := Envelope[Chip];
   If AYRegs[AY_BVOL,Chip] < 16 Then Vol1 := AYRegs[AY_BVOL,Chip] * 2 Else Vol1 := Envelope[Chip];
   If AYRegs[AY_CVOL,Chip] < 16 Then Vol2 := AYRegs[AY_CVOL,Chip] * 2 Else Vol2 := Envelope[Chip];

   If (AYRegs[AY_ENABLE,Chip] And $08) <> 0 Then VolTemp0 := 0 Else VolTemp0 := Vol0;
   If (AYRegs[AY_ENABLE,Chip] And $10) <> 0 Then VolTemp1 := 0 Else VolTemp1 := Vol1;
   If (AYRegs[AY_ENABLE,Chip] And $20) <> 0 Then VolTemp2 := 0 Else VolTemp2 := Vol2;

   VolNoise[Chip] := VolTemp0 + VolTemp1 + VolTemp2;

   If (AYRegs[AY_ENABLE,Chip] And 1) <> 0 Then Vol0 := 0;
   If (AYRegs[AY_ENABLE,Chip] And 2) <> 0 Then Vol1 := 0;
   If (AYRegs[AY_ENABLE,Chip] And 4) <> 0 Then Vol2 := 0;


   { These strange tricks are needed for getting rid   }
   { of nasty interferences between sampling frequency }
   { and "rectangular sound" (which is also the output }
   { of real AY-3-8910) we produce.                    }
{
   If Counter0 < 0 Then L0 := 0 Else L0 := Vol0;
   Inc(Counter0,Incr0);

}
   c0 :=  Counter0[Chip];
   c1 :=  Counter0[Chip] + Incr0[Chip];
   If C0 < 0 Then L0[Chip] := -16 Else L0[Chip] := 16;
   If ((c0 Xor c1) And $8000) <> 0 Then
    L0[Chip] := Round(L0[Chip] * ($8000 - (c0 And $7FFF) - (c1 And $7FFF)) / Incr0[Chip]);
   Counter0[Chip] := c1 And $FFFF;
   If L0[Chip] < 0 Then L0[Chip] := 0 Else L0[Chip] := Round(L0[Chip] * Vol0 / 16);

{
   If Counter1 < 0 Then L1 := 0 Else L1 := Vol1;
   Inc(Counter1,Incr1);
}
   c0 :=  Counter1[Chip];
   c1 :=  Counter1[Chip] + Incr1[Chip];
   If C0 < 0 Then L1[Chip] := -16 Else L1[Chip] := 16;
   If ((c0 Xor c1) And $8000) <> 0 Then
    l1[Chip] := Round(l1[Chip] * ($8000 - (c0 And $7FFF) - (c1 And $7FFF)) / Incr1[Chip]);
   Counter1[Chip] := c1 And $FFFF;
   If L1[Chip] < 0 Then L1[Chip] := 0 Else L1[Chip] := Round(L1[Chip] * Vol1 / 16);

{
   If Counter2 < 0 Then L2 := 0 Else L2 := Vol2;
   Inc(Counter2,Incr2);
}

   c0 :=  Counter2[Chip];
   c1 :=  Counter2[Chip] + Incr2[Chip];
   If C0 < 0 Then L2[Chip] := -16 Else L2[Chip] := 16;
   If ((c0 Xor c1) And $8000) <> 0 Then
    l2[Chip] := Round(l2[Chip] * ($8000 - (c0 And $7FFF) - (c1 And $7FFF)) / Incr2[Chip]);
   Counter2[Chip] := c1 And $FFFF;
   If L2[Chip] < 0 Then L2[Chip] := 0 Else L2[Chip] := Round(L2[Chip] * Vol2 / 16);

   CountNoise[Chip] := (CountNoise[Chip] And $FFFF) + IncrNoise[Chip];
   If (CountNoise[Chip] And $FFFF0000) <> 0 Then
   Begin

     { The following code is a random bit generator :) }

     NoiseGen[Chip] := NoiseGen[Chip] Shl 1;
     If (NoiseGen[Chip] And $80000000) <> 0 Then
      NoiseGen[Chip] := NoiseGen[Chip] Xor $00040001;
     StateNoise[Chip] := NoiseGen[Chip] And 1;
   End;
   If StateNoise[Chip] = 0 Then VolNoise[Chip] := 0;


{
   L0 := DToA[L0 * 2];
   L1 := DToA[L1 * 2];
   L2 := DToA[L2 * 2];
}
{   VolNoise := DToA[VolNoise * 2];}
{
   If StateNoise <> 0
    Then Buf[I] := (L0 + L1 + L2 + VolNoise) * 1
    Else Buf[I] := (L0 + L1 + L2) * 1;
}
  End; { For Chip }

  If NumChips = 1 Then Buf[I] := L0[0] + L1[0] + L2[0] + VolNoise[0]
  Else
  Begin
    J := L0[0] + L1[0] + L2[0] + VolNoise[0] +
         L0[1] + L1[1] + L2[1] + VolNoise[1];
    J := J Shr 1;
    Buf[I] := J;
  End;

 End; { For I }

 { upload the data to the audio DRAM local memory }

 P := Pointer(LongInt(PSmallSoundBuf) + ((BufPlaying Xor 1) * MAX_BUF_SIZE));
 Move(Buf,P^,AYBufSize);
End; { TimerHandler }
*)
Procedure TimerHandler1;
Var P: Pointer;
Begin
  ProcessSound;
  P := Pointer(LongInt(PSmallSoundBuf) + ((BufPlaying Xor 1) * MAX_BUF_SIZE));
  Move(Buf,P^,AYBufSize);
End; { TimerHandler1 }

{$F+}
Procedure FillBuffer;
Begin
  TimerHandler1;
End; { FillBuffer }
{$F-}

Procedure AYResetChip(Reset: Boolean);
{ reset all chip registers. }
Var I,Chip: LongInt;
Begin
  If Reset Then
  Begin
    FillChar(Buf,AYBufSize,#0);
    For Chip := 0 To NumChips - 1 Do
    Begin

      { initialize hardware registers }

      For I := 0 To 15 Do AYRegs[I,Chip] := 0;

      AYRegs[AY_ENABLE,Chip] := $3F;{077;}
{      AYRegs[AY_AVOL,Chip]   := 8;
      AYRegs[AY_BVOL,Chip]   := 8;
      AYRegs[AY_CVOL,Chip]   := 8;}
      NoiseGen[Chip]         := 1;
      Envelope[Chip]         := 0;{15;}
      StateNoise[Chip]       := 0;
      Incr0[Chip]            := 0;
      Incr1[Chip]            := 0;
      Incr2[Chip]            := 0;
      IncrEnv[Chip]          := 0;
      IncrNoise[Chip]        := 0;
      CountNoise[Chip]       := 0;
      Counter0[Chip]         := 0;
      Counter1[Chip]         := 0;
      Counter2[Chip]         := 0;
      CountEnv[Chip]         := 0;
    End; { For Chip }
  End;
{  FillChar(SmallSoundBuf,SizeOf(SmallSoundBuf),#0);}
  BufPlaying := 0;
End; { AYResetChip }

Procedure AYInit(Rate,BufSize: LongInt; Reset: Boolean);
Begin
  AYSoundRate := Rate;
  AYBufSize   := BufSize;
  AYResetChip(Reset);
End; { AYInit }

Procedure AYShutdown;
Begin
{  AYSoundRate := 0;}
  AYBufSize   := 0;
End; { AYShutdown }

Function SoundInit(Playback_Freq: Word; Reset: Boolean): Boolean;
Begin
  Sound_Is_Init := True;
  AYInit(Playback_Freq,MAX_BUF_SIZE,Reset);
  SoundInit := True;
End; { SoundInit }

Procedure SoundRestore;
Begin
  If Not Sound_Is_Init Then Exit;
  Sound_Is_Init := False;
  AYShutdown;
End; { SoundRestore }

Procedure WriteToPSG(tAddr,Value,Chip: Word);
Var
  X : LongInt;
  C : Byte;

Begin
  AYRegs[tAddr,Chip] := Value And $FF;
  Case tAddr Of
    AY_AVOL,AY_BVOL,AY_CVOL:
    Begin
      AYRegs[tAddr,Chip] := AYRegs[tAddr,Chip] And $1F;       { mask volume }
    End;
    AY_EFINE,AY_ECOARSE:
    Begin
      CountEnv[Chip] := 0;
      AYRegs[AY_ESHAPE,Chip] := AYRegs[AY_ESHAPE,Chip] And $F;
    End;
    AY_ESHAPE:
    Begin
      CountEnv[Chip] := 0;
      AYRegs[AY_ESHAPE,Chip] := AYRegs[AY_ESHAPE,Chip] And $F;
    End;
  End; { Case }

  X := AYRegs[AY_AFINE,Chip] + (Word(AYRegs[AY_ACOARSE,Chip] And $F) Shl 8);
  If X <> 0 Then Incr0[Chip] := Trunc((65536 / AYSoundRate) * (AY8910_CLOCK / 16) / X) Else Incr0[Chip] := 0;

  X := AYRegs[AY_BFINE,Chip] + (Word(AYRegs[AY_BCOARSE,Chip] And $F) Shl 8);
  If X <> 0 Then Incr1[Chip] := Trunc((65536 / AYSoundRate) * (AY8910_CLOCK / 16) / X) Else Incr1[Chip] := 0;

  X := AYRegs[AY_CFINE,Chip] + (Word(AYRegs[AY_CCOARSE,Chip] And $F) Shl 8);
  If X <> 0 Then Incr2[Chip] := Trunc((65536 / AYSoundRate) * (AY8910_CLOCK / 16) / X) Else Incr2[Chip] := 0;

  X := AYRegs[AY_NOISEPER,Chip] And $1F;
  If X <> 0 Then IncrNoise[Chip] := Trunc((65536 / AYSoundRate) * (AY8910_CLOCK / 16) / X) Else IncrNoise[Chip] := 0;

  X := AYRegs[AY_EFINE,Chip] + (Word(AYRegs[AY_ECOARSE,Chip]) Shl 8);
  If X <> 0
   Then IncrEnv[Chip] := Trunc(($200000 / AYSoundRate) * (AY8910_CLOCK / 256) / X)
   Else IncrEnv[Chip] := Trunc(($200000 / AYSoundRate) * (AY8910_CLOCK / 256) / 1);

(*
  X := AYRegs[AY_AFINE] + (Word(AYRegs[AY_ACOARSE] And $F) Shl 8);
  If X <> 0 Then Incr0 := Trunc(AY8910_CLOCK / AYSoundRate * 4 / x) Else Incr0 := 0;

  X := AYRegs[AY_BFINE] + (Word(AYRegs[AY_BCOARSE] And $F) Shl 8);
  If X <> 0 Then Incr1 := Trunc(AY8910_CLOCK / AYSoundRate * 4 / x) Else Incr1 := 0;

  X := AYRegs[AY_CFINE] + (Word(AYRegs[AY_CCOARSE] And $F) Shl 8);
  If X <> 0 Then Incr2 := Trunc(AY8910_CLOCK / AYSoundRate * 4 / x) Else Incr2 := 0;

  X := AYRegs[AY_NOISEPER] And $1F;
  If X <> 0
   Then IncrNoise := Trunc(AY8910_CLOCK / AYSoundRate * 4 / X);
   Else IncrNoise := Trunc(AY8910_CLOCK / AYSoundRate * 4);

  X := AYRegs[AY_EFINE] + (Word(AYRegs[AY_ECOARSE]) Shl 8);
  If X <> 0 Then IncrEnv := Trunc(AY8910_CLOCK / AYSoundRate * 4 / x * AYBufSize)
   Else IncrEnv := { $200000;}{ 0;}Trunc(AY8910_CLOCK / AYSoundRate * 4 / 1 * AYBufSize);
*)
(*
{  FBox(0,193,319,199,0);}
  For X := 0 To 13 Do
  Begin
    Case X Of
      0,1: C := 1;
      2,3: C := 2;
      4,5: C := 3;
        6: C := 4;
        7: C := 5;
   8,9,10: C := 6;
    11,12: C := 7;
       13: C := 8;
    End; { Case }
{    WriteOut(X * 20,193,HexByte(AYRegs[X]),C);}
    If X = tAddr
     Then Write(SndLogFile,HexByte(AYRegs[X]))
     Else Write(SndLogFile,'  ');
    If X = 7 Then Write(SndLogFile,'-') Else Write(SndLogFile,' ');
  End; { For X }
  Write(SndLogFile,'  ',Incr0:6,'   ',HexLongInt(IncrEnv),'h');
  WriteLn(SndLogFile);
*)
End; { WriteToPSG }

Procedure InitSound(Playback_Freq,Chips: Word; Reset: Boolean);
Var
  Blaster : String;
  St      : String;
  I,J     : Integer;
  WorkCh  : Char;

  Procedure ExtractWord(Var St: String; Blaster: String; I: Word);
  Var Ch: Char;
  Begin
    St := '';
    Repeat
      Ch := Blaster[I];
      Inc(I);
      If Ch <> ' ' Then St := St + Ch;
    Until (Ch = ' ') Or (I > Length(Blaster));
  End; { ExtractWord }

Begin
  NumChips := Chips;
  SoundInit(Playback_Freq,Reset);
{  FillChar(SmallSoundBuf,SizeOf(SmallSoundBuf),#0);}
  Blaster := GetEnv('BLASTER');
  If Blaster <> '' Then
  Begin
    For I := 1 To Length(Blaster) Do Blaster[I] := UpCase(Blaster[I]);
    Blaster := Trim(Blaster);
  End;
  If Blaster <> '' Then
  Begin

    { Get the port number }

    I := Pos('A',Blaster) + 1;
    ExtractWord(St,Blaster,I);
    I := 1;
    _IO_Addx := 0;
    For J := 1 To Length(St) Do
    Begin
      WorkCh := UpCase(St[Length(St) - (J - 1)]);
      If WorkCh In ['0'..'9']
       Then _IO_Addx := _IO_Addx + I * (Ord(WorkCh) - Ord('0'))
       Else _IO_Addx := _IO_Addx + I * (Ord(WorkCh) - Ord('A') + 10);
      I := I * 16;
    End; { For J }

    { Get the IRQ }

    I := Pos('I',Blaster) + 1;
    ExtractWord(St,Blaster,I);
    Val(St,_Intr_Num,I);

    { Get the DMA }

    I := Pos('D',Blaster) + 1;
    ExtractWord(St,Blaster,I);
    Val(St,_DMA,I);
  End;
  _CTV_Card_Here;
  _CTV_Detect;
  _CTV_Output(PSmallSoundBuf,MAX_BUF_SIZE * 2,Playback_Freq);
{
  Assign(SndLogFile,'INTVSND.LOG');
  ReWrite(SndLogFile);
}
End; { InitSound }

Procedure StopSound;
Begin
  _CTV_Halt;
  _CTV_Uninstall;
  SoundRestore;
{
  Close(SndLogFile);
}
End; { StopSound }

Procedure InitDToA;
Var
  I   : Integer;
  J,K : Double;

Begin
  J := 1;
  K := 1;
  For I := 1 To 15 Do K := K * Sqrt(2);
  For I := 0 To 15 Do
  Begin
    DToA[I] := Round((J / K) * 31);
    J       := J * Sqrt(2);
  End; { For I }
End; { InitDToA }

Procedure InitVolScale;
Var I,J: Integer;
Begin
  For I := 0 To 16 Do
   For J := 0 To 31 Do VolScale[I,J] := Round(I * J / 16);
End; { InitVolScale }

Begin
  InitDToA;
  InitVolScale;
  PFillBuffer := @FillBuffer;
  PSmallSoundBuf := @SmallSoundBuf;
  If (LongInt(PSmallSoundBuf) And $F) <> 0 Then
   PSmallSoundBuf := Pointer((LongInt(PSmallSoundBuf) + $10) And $FFFFFFF0);
End.
